package Conquest;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Enumeration;
import java.util.Hashtable;

import org.xml.sax.XMLReader;

/**
 * Si occupa della lettura e scrittura su file in formato XML
 * 
 */
public class ParserXML {

	private Hashtable data = new Hashtable(0);

	private String cKey = "";

	final class Sink extends org.xml.sax.helpers.DefaultHandler implements
			org.xml.sax.ContentHandler {
		final public void startElement(final String namespace,
				final String localname, final String type,
				final org.xml.sax.Attributes attributes)
				throws org.xml.sax.SAXException {
			cKey = type;
		}

		final public void characters(final char[] ch, final int start,
				final int len) {
			final String text = new String(ch, start, len);
			final String text1 = text.trim();
			if (text1.length() > 0) {
				data.put(cKey, (data.get(cKey) + "\n" + text1).replaceAll(
						"null", ""));
			}
		}
	}

	/**
	 * Restituisce i dati letti sotto una chiave
	 * 
	 * @param key
	 *            la chiave identificatrice del campo da leggere
	 */
	public String getData(String key) {
		String datas = (String) data.get(key);
		if (datas == null)
			return "null";
		datas = datas.replaceAll("\\(_MAGGIORE_\\)", ">");
		datas = datas.replaceAll("\\(_MINORE_\\)", "<");
		datas = datas.replaceAll("\\(_QUADRACHIUSA_\\)", "]");
		datas = datas.replaceAll("\\(_QUADRAAPERTA_\\)", "[");
		return datas;
	}

	final static class XML {
		final public static org.xml.sax.XMLReader makeXMLReader()
				throws Exception {
			final javax.xml.parsers.SAXParserFactory saxParserFactory = javax.xml.parsers.SAXParserFactory
					.newInstance();
			final javax.xml.parsers.SAXParser saxParser = saxParserFactory
					.newSAXParser();
			final org.xml.sax.XMLReader parser = saxParser.getXMLReader();
			return parser;
		}
	}

	/**
	 * Legge il file XML
	 * 
	 * @param name
	 *            il nome del file
	 * 
	 */
	final public void XMLRead(String name) throws Exception {
		XMLReader reader = XML.makeXMLReader();
		reader.setContentHandler(new Sink());
		reader.parse(new org.xml.sax.InputSource(name));
	}

	/**
	 * Scrive sul file XML
	 * 
	 * @param info
	 *            le informazioni da scrivere
	 * @param name
	 *            il nome del file
	 * 
	 */
	final public void XMLWrite(Hashtable info, String name) throws Exception {
		BufferedWriter br = null;
		FileWriter r = null;
		r = new FileWriter(name);
		br = new BufferedWriter(r);
		Enumeration en = info.keys();
		br.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		br.write("<info>");
		while (en.hasMoreElements()) {
			String tag = (String) en.nextElement();
			String value = info.get(tag).toString().replaceAll("<",
					"(_MINORE_)");
			value = value.replaceAll(">", "(_MAGGIORE_)");
			value = value.replaceAll("\\]", "(_QUADRACHIUSA_)");
			value = value.replaceAll("\\[", "(_QUADRAAPERTA_)");
			String entry = "<" + tag + ">" + value + "</" + tag + ">\n";
			br.write(entry);
		}
		br.write("</info>");
		br.close();
		r.close();
	}

}
